<template>
  <v-card>
    <v-toolbar color='primary' dense>
      <v-toolbar-title>Новая сделка</v-toolbar-title>
    </v-toolbar>
    <container>
      <v-row>
        <v-col cols='12'>
          <v-select v-model='form.ownerId' label='Создатель сделки' :items='owners' item-text='text' item-value='value'  hide-details />
        </v-col>
        <v-col cols='12'>
          <v-select v-model='form.type' label='Тип' :items='types' item-text='text' item-value='value'  hide-details/>
        </v-col>
        <v-col cols='12'>
          <v-text-field v-model.number='form.amount' label='Сумма LDS' type='number' hide-details/>
        </v-col>
        <v-col cols='12'>
          <v-text-field v-model.number='form.price' label='Стоимость RUB' type='number' hide-details/>
        </v-col>
        <v-col cols='12'>
          <v-text-field :value='pricePerLds' label='Цена за LDS' readonly type='number' hide-details/>
        </v-col>
        <v-col cols='12'>
          <v-btn color='primary' @click='submit' :disabled='disabled'>
            Создать сделку
          </v-btn>
        </v-col>
      </v-row>
    </container>
  </v-card>
</template>

<script lang='ts'>

import Vue from 'vue';
import Component from 'vue-class-component';
import { AuthInfoResponse } from '@/api/courses';
import { Prop } from 'vue-property-decorator';
import { CreateOfferCommand } from '@/api/ledius-token';
import { OfferTypeEnum } from '@/api/patch/ledius-token.enums';

@Component({})
export default class OfferCreateForm extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly authInfo!: AuthInfoResponse;

  private disabled: boolean = false;

  private get types(): { text: string, value: number, description: string, }[] {
    return [
      { text: 'Продажа', value: OfferTypeEnum.SELL, description: 'Клиент продает LDS за RUB' },
      { text: 'Покупка', value: OfferTypeEnum.BUY, description: 'Клиент покупает LDS за RUB' }
    ];
  }

  private readonly form: CreateOfferCommand = {
    ownerId: '',
    type: OfferTypeEnum.BUY as never,
    amount: '',
    publishAt: new Date().toISOString(),
    price: '' as never
  };

  private get pricePerLds(): number {
    if (this.form.price && this.form.amount) {
      return Number(this.form.price) / Number(this.form.amount);
    }
    return 0;
  }

  private get owners(): { text: string, value: string }[] {
    return [
      { text: this.authInfo.email, value: this.authInfo.id }
    ];
  }

  private get validForm(): boolean {
    if (!this.form.ownerId) {
      return false;
    }
    if (!String(this.form.type)) {
      return false;
    }
    if (!this.form.price) {
      return false;
    }
    if (!this.form.amount) {
      return false;
    }
    return true;
  }

  private async submit(): Promise<void> {
    if (!this.validForm) {
      return;
    }
    this.disabled = true;
    try {
      await this.$store.dispatch('exchange/offers/create', {
        price: this.form.price * 100,
        amount: BigInt(Number(this.form.amount) * (10 ** 18)).toString(),
        publishAt: this.form.publishAt,
        ownerId: this.form.ownerId,
        type: this.form.type
      } as CreateOfferCommand);
      await this.$router.push({
        name: 'Offers'
      });
    } finally {
      this.disabled = false;
    }
  }
}

</script>
